.686
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc
include \masm32\include\comctl32.inc
include \masm32\include\msvcrt.inc

include \masm32\macros\macros.asm

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\msvcrt.lib

include PCRE.inc
includelib PCRE.lib

.data

; PCRE Variables;

ptrPCRE dd 0
ptrOutVec dd 0

.data?
gIst dd ?
gWnd dd ?
gHep dd ?
gSet dd ?
gEdit dd ?

; PCRE Variables;

szeOutVec dd ?
CaptureCnt dd ?

ptrError dd ?
offError dd ?

.code

ALIGN 4

eprintf PROC C uses ebx hWnd:DWORD,Format:DWORD,Args:VARARG
LOCAL Buffer[1024+4096]:BYTE

	invoke SendMessage,hWnd,WM_GETTEXT,4096,addr Buffer	
	mov ebx,eax
	
	lea edx,[Buffer+eax]	
	invoke crt__vsnprintf,edx,1024,Format,addr Args
	add ebx,eax
	
	lea edx,[Buffer]
	cmp ebx,4090
	jle @F
	lea edx,[edx+ebx-4090]
@@:	invoke SendMessage,hWnd,WM_SETTEXT,0,edx
	invoke SendMessage,hWnd,EM_LINESCROLL,0,1024
ret
eprintf ENDP

DlgProc PROC uses edi esi ebx hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

LOCAL buf[512]:BYTE 
LOCAL buf2[512]:BYTE 

LOCAL stringBuf[512]:BYTE

	Switch uMsg

	Case WM_INITDIALOG
		mov eax,hWnd
		mov gWnd,eax ; Needed for the StrItem function
		invoke GetProcessHeap
		mov gHep,eax ; Needed by the memory functions in LinkedList and HashSet
		
		invoke GetDlgItem,hWnd,3002
		mov gEdit,eax
		
		invoke SetDlgItemText,hWnd,3000,CTXT("^(b+|a){1,2}(c)")
		invoke SetDlgItemText,hWnd,3001,CTXT("bbac")

	return 1

	Case WM_COMMAND
	
		Switch wParam

		Case 1000 ; Exit
		
			invoke SendMessage,hWnd,WM_CLOSE,0,0

		Case 1001 ; Compile

			.if ptrOutVec != 0
				invoke GlobalFree,ptrOutVec
				mov ptrOutVec,0
			.endif
			.if ptrPCRE != 0
				invoke crt_free,ptrPCRE
				mov ptrPCRE,0
			.endif
		
			invoke GetDlgItemText,hWnd,3000,addr stringBuf,512
		
			invoke pcre_compile, addr stringBuf, 0, addr ptrError, addr offError, 0
			mov ptrPCRE,eax
			.if eax == 0			
				invoke eprintf,gEdit,CTXT("Error compiling RegEx.%s"),SADD(13,10)
			.else
				invoke eprintf,gEdit,CTXT("RegEx compiled, address: %Xh.%s"),ptrPCRE,SADD(13,10)
			.endif
			
			invoke pcre_fullinfo,ptrPCRE,0,PCRE_INFO_CAPTURECOUNT,addr CaptureCnt
			add CaptureCnt,1
			
			invoke eprintf,gEdit,CTXT("Allocating space for %i matches.%s"),CaptureCnt,SADD(13,10)
			
			mov eax,CaptureCnt
			imul eax,3
			mov szeOutVec,eax
			
			shl eax,2
			invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			mov ptrOutVec,eax
			
			invoke GetDlgItem,hWnd,1002
			invoke EnableWindow,eax,1
			invoke GetDlgItem,hWnd,1003
			invoke EnableWindow,eax,1

		Case 1002 ; Match
		
			invoke GetDlgItemText,hWnd,3001,addr stringBuf,512
		
			invoke StrLen,addr stringBuf
			invoke pcre_exec,ptrPCRE,0,addr stringBuf,eax,0,0,ptrOutVec,szeOutVec
			mov ebx,eax
			;invoke eprintf,gEdit,CTXT("%i%s"),ebx,SADD(13,10)
			
			.if SDWORD ptr ebx <= 0
				invoke eprintf,gEdit,CTXT("Error: No Match!%s"),SADD(13,10)
			.else			
				invoke eprintf,gEdit,CTXT("Found %i matches.%s---%s"),ebx,SADD(13,10),SADD(13,10)
			
				shl ebx,3	; multiply *2 and *4 (DWORD size)				
				
				mov edi,ptrOutVec
				mov esi,0
				
				add edi,ebx
				neg ebx
				
				.while ebx != 0
									
					mov eax,[edi+ebx]
					mov ecx,[edi+ebx+4]
					sub ecx,eax
					invoke szMid,addr stringBuf,addr buf2,eax,ecx
					
					invoke eprintf,gEdit,CTXT("%i:%s%s"),esi,addr buf2,SADD(13,10)												
					
					inc esi
					add ebx,8
				.endw							
				
			.endif
			
		Case 1003 ; Free
			
			invoke crt_free,ptrPCRE
			invoke GlobalFree,ptrOutVec
			
			mov ptrPCRE,0
			mov ptrOutVec,0
			
			invoke eprintf,gEdit,CTXT("Freed RegEx memory.%s"),SADD(13,10)

			invoke GetDlgItem,hWnd,1002
			invoke EnableWindow,eax,0
			invoke GetDlgItem,hWnd,1003
			invoke EnableWindow,eax,0

		Endsw

	Case WM_CLOSE
	
		.if ptrOutVec != 0
			invoke GlobalFree,ptrOutVec
			mov ptrOutVec,0
		.endif
		.if ptrPCRE != 0
			invoke crt_free,ptrPCRE
			mov ptrPCRE,0
		.endif
		
		invoke EndDialog,hWnd,0
	Endsw

	xor eax, eax
	ret
DlgProc EndP

Start:

invoke GetModuleHandle,eax
mov gIst,eax

invoke DialogBoxParam,eax,1,0,addr DlgProc,0

invoke ExitProcess,0
invoke InitCommonControlsEx,0
END Start